<template>
    <div class="container">
      <h3>&Aacute;reas</h3>
  
      <div class="card">
        <div class="card-content">
          <form @submit.prevent="nuevo()">
            <h5>Nueva &Aacute;rea</h5>
            <p>Nombre &Aacute;rea: <input type="text" v-model="payload.nombre" required /></p>
            <p>Nombre Encargado: <input type="text" v-model="payload.encargado" required /></p>
            <p>N&uacute;mero de Funcionarios: <input type="number" v-model="payload.numero_funcionarios" required /></p>
            <button type="submit" class="waves-effect maves-light btn-small">Agregar</button>
          </form>
        </div>
      </div>
  
      <div class="card">
        <div class="card-content">
          <form @submit.prevent="getList()">
            <h5>Buscar &Aacute;rea</h5>
            <p>Nombre &Aacute;rea: <input type="search" v-model="search" @search="getList()" /></p>
            <button type="submit" class="waves-effect maves-light btn-small">Buscar</button>
          </form>
        </div>
      </div>
  
      <div class="card">
        <div class="card-content">
          <table>
            <thead>
              <tr>
                  <th>Id</th>
                  <th>Nombre</th>
                  <th>Encargado</th>
                  <th>No de Funcionarios</th>
                  <th></th>
                  <th></th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="item in items">
                <td>{{item.id}}</td>
                <td>{{item.nombre}}</td>
                <td>{{item.encargado}}</td>
                <td>{{item.numero_funcionarios}}</td>
                <td><a class="btn-floating btn-large waves-effect waves-light red"><i class="material-icons" @click="eliminar(item.id)">delete</i></a></td>
                <td><a class="btn-floating btn-large waves-effect waves-light blue"><i class="material-icons" @click="update(item.id)">edit</i></a></td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
    </div>
  </template>
  
  <script>
  
  export default {
    name: 'AreaView',
    data(){
      const api = process.env.VUE_APP_API;
      return {
        api,
        items:[],
        search: '',
        payload:{
          nombre: null,
          encargado: null,
          numero_funcionarios: null
        }
      }
    },
    methods: {
      update(id){
        this.$router.push('/area/'+id);
      },
      eliminar(id){
        if(confirm("Esta seguro de eliminar esta Área?")){
          this.axios({
            method: 'delete',
            url: this.api+'/areas/'+id
          }).
          then((response)=>{
            this.getList();
          }).
          catch((error)=>{
            console.log(error);
          });
        }
      },
      nuevo(){
        this.axios({
          method: 'post',
          url: this.api+'/areas',
          data: this.payload
        }).
        then((response)=>{
          this.getList();
          this.payload.nombre = null;
          this.payload.encargado = null;
          this.payload.numero_funcionarios = null;
          console.log(response);
        }).
        catch((error)=>{
          console.log(error);
        });
      },
      getList(name, value){
        this.axios({
          method: 'get',
          url: this.api+'/areas?q=' + this.search
        }).
        then((response)=>{
          this.items = response.data;
        }).
        catch((error)=>{
          console.log(error);
        })
      }
    },
    components: {
     
    },
    mounted(){
      this.getList();
      var elems = document.querySelectorAll('select');
      var instances = M.FormSelect.init(elems);
    }
  }
  </script>
  